//button is pin 2
//led is pin 6
//sd cards are shield pins
//A0 is microphone out


#include <SD.h>
#include <SPI.h>
#include <TMRpcm.h>
#define SD_ChipSelectPin 10
TMRpcm audio;
int audiofile = 0;
unsigned long i = 0;
bool recmode = 0;
static unsigned long last_interrupt_time;
unsigned long interrupt_time;

void setup() {
  pinMode(A0, INPUT);
  pinMode(6, OUTPUT);
  pinMode(2, INPUT_PULLUP);
  attachInterrupt(digitalPinToInterrupt(2), interruptHandlerStartRecord, LOW);
  SD.begin(SD_ChipSelectPin);
  audio.CSPin = SD_ChipSelectPin;
  last_interrupt_time = 0;
  Serial.begin(115200);
}

void loop() {
}

void interruptHandlerStartRecord() {
  {
    interrupt_time = millis();
    // If interrupts come faster than 20ms, assume it's a bounce and ignore
    if (interrupt_time - last_interrupt_time > 20) {
      button();
    }
    last_interrupt_time = interrupt_time;
  }
}

void button() {
  while (i < 300000) {
    i++;
  }
  i = 0;
  if (recmode == 0) {
    recmode = 1;
    digitalWrite(6, HIGH);
    audio.startRecording("birdnoise.wav", 12000, A0);
  } else {
    audio.stopRecording("birdnoise.wav");
    sendFile("birdnoise.wav");
    recmode = 0;
    Serial.println("sent file");
    digitalWrite(6, LOW);
    SD.remove("birdnoise.wav");
    Serial.println("removed file from SD");
  }
}

void sendFile(String fileName) {
  // open the file. note that only one file can be open at a time,
  // so you have to close this one before opening another.
  Serial.println("Transferring file to Rpi...");
  File dataFile = SD.open(fileName);
  unsigned long num_bytes = dataFile.size();
  //Send the filename with the first byte "F" for filename
  Serial.println("F" + fileName);
  //Send the file size with the first byte "S" for file size
  Serial.println("S" + String(num_bytes));
  delay(2000);
  //Send the data
  if (dataFile) {
    while (dataFile.available()) {
      Serial.write(dataFile.read());
    }
    dataFile.close();
  }
  // if the file isn't open, pop up an error:
  else {
    Serial.println("error opening file");
  }
}
