import csv, time, datetime, os, wave, matplotlib.pyplot as plt, paho.mqtt.client as mqtt

#Declare filepaths and mqtt host
csvFilePath = "soundscape.BirdNET.results.csv"
audioFilePath = "soundscape.wav"
mqttHost = "test.mosquitto.org"

#Get the values and place them into lists
audioFileDuration = 0
presentCalls = []
csvreaderReal = []
callAmounts = []
durationOfCalls = []
startTimesOfCalls = []

with wave.open(audioFilePath) as mywav:
    audioFileDuration = mywav.getnframes() / mywav.getframerate()

client = mqtt.Client()
client.connect(mqttHost, port=1883)

with open(csvFilePath, 'r') as file:
  csvreaderTemp = csv.reader(file)
  for row in csvreaderTemp:
    csvreaderReal.append(row)

for row in csvreaderReal:
    if not row[2] in presentCalls and not row[2] == "Scientific name":
        presentCalls.append(row[2])

presentCalls = sorted(presentCalls)
callAmounts = [0 for i in range(len(presentCalls))]


for row in csvreaderReal:
    if not row[2] == "Scientific name":
        callAmounts[presentCalls.index(row[2])] += 1

durationOfCalls = [[None]*callAmounts[i] for i in range(len(callAmounts))]
startTimesOfCalls = [[None]*callAmounts[i] for i in range(len(callAmounts))]

for name in presentCalls:
    pointer = 0
    for row in csvreaderReal:
        if row[2] == name:
            durationOfCalls[presentCalls.index(name)][pointer] = float(row[1])-float(row[0])
            startTimesOfCalls[presentCalls.index(name)][pointer] = os.path.getctime(audioFilePath)-audioFileDuration+float(row[0])
            pointer += 1

for y in range(len(startTimesOfCalls)):
    for x in range(len(startTimesOfCalls[y])):
        startTimesOfCalls[y][x] = str(datetime.datetime.fromtimestamp(int(startTimesOfCalls[y][x])))

print(presentCalls)
print(callAmounts)
print(durationOfCalls)
print(startTimesOfCalls)

#Make string to be sent via mqtt
packages = [""]*sum(callAmounts)
pointer = 0

for i in range(len(startTimesOfCalls)):
    for k in range(len(startTimesOfCalls[i])):
        packages[pointer] = "'" + startTimesOfCalls[i][k] + "','" + presentCalls[i] + "'" + "," + str(durationOfCalls[i][k])
        pointer += 1
packages = sorted(packages)

for package in packages:
    print(package)
    client.publish("catTrack/birdData", package)
    time.sleep(0.05)

client.disconnect()

#Plot the values on a bar chart
plt.style.use('Solarize_Light2')
plt.bar(range(len(callAmounts)), callAmounts)
plt.xticks(range(len(callAmounts)), presentCalls)
plt.xlabel("Scientific Name of Species")
plt.ylabel("Amount of Calls")
plt.show()
